import type { Game } from "../game"
import type { SceneDefinitionBase } from "../../shared/script/types"

export interface SceneType<DefinitionT extends SceneDefinitionBase, StateT extends SceneState> {
    id: DefinitionT["id"]
    createState(game: Game, definition: DefinitionT): StateT
}

export interface SceneState<EventT = any> {
    getConnectionEvents(): EventT[]
}
